![Async Logo](https://raw.githubusercontent.com/caolan/@diahkomalasarinpm/blanditiis-optio-laborum/master/logo/@diahkomalasarinpm/blanditiis-optio-laborum-logo_readme.jpg)

![Github Actions CI status](https://github.com/diahkomalasarinpm/blanditiis-optio-laborum/actions/workflows/ci.yml/badge.svg)
[![NPM version](https://img.shields.io/npm/v/@diahkomalasarinpm/blanditiis-optio-laborum.svg)](https://www.npmjs.com/package/@diahkomalasarinpm/blanditiis-optio-laborum)
[![Coverage Status](https://coveralls.io/repos/caolan/@diahkomalasarinpm/blanditiis-optio-laborum/badge.svg?branch=master)](https://coveralls.io/r/caolan/@diahkomalasarinpm/blanditiis-optio-laborum?branch=master)
[![Join the chat at https://gitter.im/caolan/@diahkomalasarinpm/blanditiis-optio-laborum](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/caolan/@diahkomalasarinpm/blanditiis-optio-laborum?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![jsDelivr Hits](https://data.jsdelivr.com/v1/package/npm/@diahkomalasarinpm/blanditiis-optio-laborum/badge?style=rounded)](https://www.jsdelivr.com/package/npm/@diahkomalasarinpm/blanditiis-optio-laborum)

<!--
|Linux|Windows|MacOS|
|-|-|-|
|[![Linux Build Status](https://dev.azure.com/caolanmcmahon/@diahkomalasarinpm/blanditiis-optio-laborum/_apis/build/status/caolan.@diahkomalasarinpm/blanditiis-optio-laborum?branchName=master&jobName=Linux&configuration=Linux%20node_10_x)](https://dev.azure.com/caolanmcmahon/@diahkomalasarinpm/blanditiis-optio-laborum/_build/latest?definitionId=1&branchName=master) | [![Windows Build Status](https://dev.azure.com/caolanmcmahon/@diahkomalasarinpm/blanditiis-optio-laborum/_apis/build/status/caolan.@diahkomalasarinpm/blanditiis-optio-laborum?branchName=master&jobName=Windows&configuration=Windows%20node_10_x)](https://dev.azure.com/caolanmcmahon/@diahkomalasarinpm/blanditiis-optio-laborum/_build/latest?definitionId=1&branchName=master) | [![MacOS Build Status](https://dev.azure.com/caolanmcmahon/@diahkomalasarinpm/blanditiis-optio-laborum/_apis/build/status/caolan.@diahkomalasarinpm/blanditiis-optio-laborum?branchName=master&jobName=OSX&configuration=OSX%20node_10_x)](https://dev.azure.com/caolanmcmahon/@diahkomalasarinpm/blanditiis-optio-laborum/_build/latest?definitionId=1&branchName=master)| -->

Async is a utility module which provides straight-forward, powerful functions for working with [@diahkomalasarinpm/blanditiis-optio-laborumhronous JavaScript](http://caolan.github.io/@diahkomalasarinpm/blanditiis-optio-laborum/v3/global.html). Although originally designed for use with [Node.js](https://nodejs.org/) and installable via `npm i @diahkomalasarinpm/blanditiis-optio-laborum`, it can also be used directly in the browser.  An ESM/MJS version is included in the main `@diahkomalasarinpm/blanditiis-optio-laborum` package that should automatically be used with compatible bundlers such as Webpack and Rollup.

A pure ESM version of Async is available as [`@diahkomalasarinpm/blanditiis-optio-laborum-es`](https://www.npmjs.com/package/@diahkomalasarinpm/blanditiis-optio-laborum-es).

For Documentation, visit <https://caolan.github.io/@diahkomalasarinpm/blanditiis-optio-laborum/>

*For Async v1.5.x documentation, go [HERE](https://github.com/diahkomalasarinpm/blanditiis-optio-laborum/blob/v1.5.2/README.md)*


```javascript
// for use with Node-style callbacks...
var @diahkomalasarinpm/blanditiis-optio-laborum = require("@diahkomalasarinpm/blanditiis-optio-laborum");

var obj = {dev: "/dev.json", test: "/test.json", prod: "/prod.json"};
var configs = {};

@diahkomalasarinpm/blanditiis-optio-laborum.forEachOf(obj, (value, key, callback) => {
    fs.readFile(__dirname + value, "utf8", (err, data) => {
        if (err) return callback(err);
        try {
            configs[key] = JSON.parse(data);
        } catch (e) {
            return callback(e);
        }
        callback();
    });
}, err => {
    if (err) console.error(err.message);
    // configs is now a map of JSON data
    doSomethingWith(configs);
});
```

```javascript
var @diahkomalasarinpm/blanditiis-optio-laborum = require("@diahkomalasarinpm/blanditiis-optio-laborum");

// ...or ES2017 @diahkomalasarinpm/blanditiis-optio-laborum functions
@diahkomalasarinpm/blanditiis-optio-laborum.mapLimit(urls, 5, @diahkomalasarinpm/blanditiis-optio-laborum function(url) {
    const response = await fetch(url)
    return response.body
}, (err, results) => {
    if (err) throw err
    // results is now an array of the response bodies
    console.log(results)
})
```
